#include <iostream>
#include <vector>
#include <cassert>

using namespace std;
const int nmax = 305;
string s[nmax];
int dp[2*nmax][nmax][nmax];
int n;
const int inf=-(1<<30);
vector<pair<int,int>> dirs({{1,0},{0,1}});
int getDiagonal(int line, int col){
    return line + col;
}
bool inside(int line, int col){
    return 1<=line && line<=n && 1<=col && col <=n;
}
int memo(int line1, int col1, int line2, int col2){
    int diag = getDiagonal(line1, col1);
    assert(diag == getDiagonal(line2, col2));
    if(line1 >= line2 && diag != getDiagonal(n, n)){
        return inf;
    }
    if((!inside(line1,col1))||(!inside(line2, col2)))
        return inf;
    if (dp[diag][line1][line2])
        return dp[diag][line1][line2];
    int ret = inf;
    int same = (s[line1][col1] == s[line2][col2]);
    for(auto d1: dirs)
        for(auto d2: dirs)
            ret = max(ret, memo(line1-d1.first, col1-d1.second, line2-d2.first,col2-d2.second) + same);
    dp[diag][line1][line2] = ret;
    return ret;
}
int main()
{
    //freopen("data.in", "r", stdin);
    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        s[i] = " " + s[i];
    }
    dp[getDiagonal(1, 2)][1][2] = 1 + int(s[1][2] == s[2][1]);
    cout<<memo(n,n,n,n);
    return 0;
}
